
\CopiedChapter{\footnotemark[1]\textsuperscript{,}\footnotemark[2]}{The multi-level \textit{hp}-finite element method}
\label{sec:mlhp}
{

\input{chapters/tikzhelper.tex}
\renewcommand\picsDir{chapters/04_mlhp_pics}

\begin{figure}[h]
  \includeTikz{}{hprefinements_replacement}
  \hfill
  \includeTikz{}{hprefinements_superposition}
  
  \vspace{0.3cm}
  
  \begin{minipage}[b]{0.4\linewidth}%
    \subcaption{Refine by replacement}%
  \end{minipage}%
  \hspace{0.1\linewidth}
  \begin{minipage}[b]{0.4\linewidth}%
    \subcaption{Refine by superposition}%
  \end{minipage}%
  \caption{Comparison of $hp$-refinement strategies. \reprintedB}
  \label{fig:mlhp:hprefinementtypes} 
\end{figure}

Refining the finite element discretization by only increasing the polynomial degree is often not the best strategy, as the element size must also be reduced to recover exponential convergence for solutions with reduced regularity. Even for smooth solutions, starting with several levels of $h$-refinement until the solution becomes smooth enough on each element is often more efficient, as $p$-refinement is more expensive per degree of freedom than $h$-refinement. However, replacing coarse finite elements with a set of finer ones introduces hanging nodes --- element interfaces that are subdivided on one side but not on the other. The presence of hanging nodes greatly complicates the construction of continuous basis functions, as the shape functions of finer elements cannot be directly combined with shape functions on the coarser element. Instead, combinations of shape functions must be constrained and connected. The complexity of this process increases strongly with more spatial dimensions \review{as well as} mesh irregularity \parencite{Demkowicz1989, Demkowicz2006, Zander2016}.

\begin{figure}[h!]
  \begin{minipage}[c]{0.46\linewidth}
    \includeTikz{width=\linewidth}{hpmesh_fullids}%
    \subcaption{Full cell numbering}

    \vspace{1.695cm}

    \includeTikz{}{hpmesh_leafids}%
    \hfill
    \subcaption{Leaf cell (element) numbering}
    \label{fig:mlhp:datastructure:example:leaves} 
  \end{minipage}
  \hfill
  \begin{minipage}[c]{0.41\linewidth}
    \newcommand{\cR}[1]{\textcolor{red}{#1}}
    \newcommand{\cB}[1]{\textcolor{blue}{#1}}
    \centering
    \begin{tabular}{lrrrrrrr}
      \toprule
      Cell  & $n_l$   & $n_r$   & $n_b$   & $n_t$   & $P$ & $\;R$ & $\;L$ \\ 
      \midrule                                                              
      0     & \cB{-1} &      2  & \cB{-1} &      1  &  -1 &     0 &     0 \\  
      1     & \cB{-1} &      3  &      0  & \cB{-1} &  -1 &     0 &     0 \\  
      2     &      0  & \cB{-1} & \cB{-1} &      3  &  -1 &     0 &     1 \\  
      3     &      1  & \cB{-1} &      2  & \cB{-1} &  -1 &     0 &     0 \\  
      4     & \cB{-1} &      6  & \cB{-1} &      5  &   0 &     1 &     1 \\  
      5     & \cB{-1} &      7  &      4  &      8  &   0 &     1 &     1 \\  
      6     &      4  &  \cR{2} & \cB{-1} &      7  &   0 &     1 &     1 \\  
      7     &      5  &  \cR{2} &      6  &     10  &   0 &     1 &     0 \\  
      8     & \cB{-1} &     10  &      5  &      9  &   1 &     1 &     1 \\  
      9     & \cB{-1} &     11  &      8  & \cB{-1} &   1 &     1 &     1 \\  
      10    &      8  &     12  &      7  &     11  &   1 &     1 &     0 \\  
      11    &      9  &     13  &     10  & \cB{-1} &   1 &     1 &     1 \\  
      12    &     10  &     14  &  \cR{2} &     13  &   3 &     1 &     0 \\  
      13    &     11  &     15  &     12  & \cB{-1} &   3 &     1 &     1 \\  
      14    &     12  & \cB{-1} &  \cR{2} &     15  &   3 &     1 &     1 \\  
      15    &     13  & \cB{-1} &     14  & \cB{-1} &   3 &     1 &     1 \\  
      16    &  \cR{5} &     18  &  \cR{6} &     17  &   7 &     2 &     1 \\  
      17    &  \cR{5} &     19  &     16  &     20  &   7 &     2 &     1 \\  
      18    &     16  &  \cR{2} &  \cR{6} &     19  &   7 &     2 &     1 \\  
      19    &     17  &  \cR{2} &     18  &     22  &   7 &     2 &     1 \\                                                               
      20    &  \cR{8} &     22  &     17  &     21  &  10 &     2 &     1 \\
      21    &  \cR{8} &     23  &     20  & \cR{11} &  10 &     2 &     1 \\  
      22    &     20  &     24  &     19  &     23  &  10 &     2 &     1 \\ 
      23    &     21  &     25  &     22  & \cR{11} &  10 &     2 &     1 \\  
      24    &     22  &     26  &  \cR{2} &     25  &  12 &     2 &     1 \\  
      25    &     23  &     27  &     24  & \cR{13} &  12 &     2 &     1 \\  
      26    &     24  & \cR{14} &  \cR{2} &     27  &  12 &     2 &     1 \\  
      27    &     25  & \cR{14} &     26  & \cR{13} &  12 &     2 &     1 \\     
      \bottomrule
    \end{tabular}
    \subcaption{Data structure}
  \end{minipage}
  \caption{Essential topological data: left, right, bottom and top neighbors $n_l$, $n_r$, $n_b$, $n_t$, parent index $P$, refinement level $R$, and a flag $L$ marking the leaf cells. \reprintedA}
  \label{fig:mlhp:datastructure:example}
\end{figure}

The multi-level $hp$-method circumvents the challenge of treating hanging nodes by keeping coarse elements during the refinement. Allowing these coarse elements to support shape functions \review{in them} naturally resolve\review{s} cases where neighboring elements have a different refinement level. Instead of trying to connect the coarse shape functions to the finer ones, the functions on the original coarse neighbor (that is now overlayed with finer elements) are activated. The shape functions from neighboring elements are combined using this idea, essentially reducing the problem of constructing an $hp$-basis to creating multiple levels of $p$-finite element meshes. Figure~\ref{fig:mlhp:hprefinementtypes} compares the replacement and overlay strategies and demonstrates how coarse shape functions are completed on the coarse parent of the finer neighbors.

\CopiedSection{\footnotemark[1]}{Hierarchical refinement and data structure}
\label{sec:mlhp:datastructure}

The refinement process starts with a base mesh, where cells marked for refinement are overlayed by $2^d$ subcells from bisecting the original cell in each coordinate direction. Performing this process recursively on overlay cells yields a $2^d$-ary refinement tree. The choice to refine can use an error indicator or a priori knowledge of the solution. All cells within the refinement tree can support basis functions, although finite elements are chosen only as leaf cells. 

A central aspect of the presented framework is to identify a lightweight data structure that can store all essential information for constructing an $hp$-basis. 
The algorithms introduced in this \review{chapter require} for each cell \review{the index of its} parent \review{cell}, \review{its} refinement level, \review{the indices of its} neighbors on the same or a lower refinement level, and the information whether \review{it} is a leaf. The neighbor \review{indices} are stored in a $(n_{\text{cell}}, d, 2)$ sized array (denoted as $N$), and for the other relations, simple one-dimensional arrays with one entry per cell are used. The roots of the refinement tree can be identified by choosing the parent cell index $-1$ for cells without a parent. An entry in the neighbor array can correspond to an \textit{internal interface} (neighbor exists and has same refinement level), \textit{internal boundary} (neighbor exists and has lower refinement level), and \textit{external boundary} (neighbor does not exist, face is part of the domain boundary). External boundaries are assigned the \textit{no-cell} value, and internal boundaries are assigned the index of the coarser leaf cell. Figure~\ref{fig:mlhp:datastructure:example} sketches a simple example mesh with two \review{refinement} levels.

The multi-level $hp$-method introduces two main challenges: linear independence must be preserved and the overlay functions must be zero on internal boundaries to guarantee continuity in the hierarchical sum of all shape functions. The following section addresses these challenges and shows how to automatically resolve them with little implementation effort.

\begin{remark}
  \item The internal boundaries are the multi-level $hp$ equivalent of the hanging nodes from classical $hp$-finite elements. The treatment of hanging nodes introduces constraints to the shape functions on both sides. In contrast, the multi-level $hp$-method simply imposes homogeneous Dirichlet conditions on internal boundaries (by removing active shape functions on them).
\end{remark}

\begin{remark}
  \item One can exploit the redundancy in the data structure to reduce the amount of storage that is needed for the meshes. For example, the refinement levels and leaf flags can be trivially constructed from the parent indices on the fly. However, additional information, like the geometric mapping function of each cell, may \review{also} be needed.
\end{remark}

\CopiedSection{\footnotemark[1]}{Tensor-product masks}
\label{sec:mlhp:masks}

\begin{figure}[h]
  \centering
  \includeTikz{width=0.40\textwidth}{hpmesh_degrees}%
  \caption{Polynomial degrees for each finite element (Figure~\ref{fig:mlhp:datastructure:example:leaves}) and coordinate direction. \reprintedA}
  \label{fig:mlhp:masks:degrees}
\end{figure}

This section constructs the tensor-product masks for all cells (leaves and non-leaves) in the refinement tree introduced in the previous section (with an arbitrary refinement depth). The tensor-product masks again activate the right shape functions on each cell, such that they can combine into globally continuous, \review{linearly} independent $hp$-basis functions that are complete up to the selected polynomial degrees inside each element. These polynomial degrees are only assigned to the leaves (the finite elements), and they can again vary in the local directions. Figure~\ref{fig:mlhp:masks:degrees} shows the polynomial degrees chosen for the example mesh introduced in Figure~\ref{fig:mlhp:datastructure:example}. The following algorithm extends the ideas of Section~\ref{sec:pfem:masks} to construct the multi-level $hp$ tensor-product masks in four steps (\review{see} Figures~\ref{fig:mlhp:masks:construction:initial}~-~\ref{fig:mlhp:masks:construction:step4:x} and Algorithm~\ref{alg:mlhp:masks:construction}).

\begin{figure}
  \centering
  \includeTikz{}{mlhp_masks_initial}%
  \caption{Initial tensor-product masks corresponding to degrees in Figure~\ref{fig:mlhp:masks:degrees}. \reprintedA}
  \label{fig:mlhp:masks:construction:initial}
\end{figure}


\begin{figure}
  \centering
  \includeTikz{}{mlhp_masks_step2x}%
  \caption{Restore continuity after initial activation: Slices normal to $x$-axis. \reprintedA}
  \label{fig:mlhp:masks:construction:step2:x}
\end{figure}

\begin{figure}
  \centering
  \includeTikz{}{mlhp_masks_step2y}%
  \caption{Restore continuity after initial activation: Slices normal to $y$-axis. \reprintedA}
  \label{fig:mlhp:masks:construction:step2:y}
\end{figure}

\begin{figure}
  \centering
  \includeTikz{}{mlhp_masks_step3}%
  \caption{Deactivate internal boundaries (step 3). \reprintedA}
  \label{fig:mlhp:masks:construction:step3}
\end{figure}

\begin{figure}
  \centering
  \includeTikz{}{mlhp_masks_step4x}%
  \caption{Communicate zero Dirichlet conditions to neighbors (step 4). \reprintedA}
  \label{fig:mlhp:masks:construction:step4:x}
\end{figure}

\begin{algorithm}%
\begin{lstlisting}[gobble=2,mathescape]
  // Replaces p-fem version; requires neighbor to exist with same level
  void operateOnInterfaces(NdArrayList<Type>& $A$, Neighbors $N$, Levels $L$, Op op)
  {
      for(int $a$ from 0 to d - 1)              // For d coordinate axes
          for(int $i$ from 0 to size($A$) - 1)     // For all cells
              if(int $N_a$ = $N$($i$, $a$, $1$); $N_a \neq -1$ and $L$($i$) == $L$($N_a$))
                  operateOnInterface($A$($i$), $A$($N_a$), $a$, op);
  }
  // Deactivate first (f == 0) or second (f == 1) array slice normal to axis n
  void deactivateSlice(Mask& $M_i$, int $n$, int $f$)
  {
      Vector $s^n$ = removeEntry(sizes($M_i$), n);
      
      for(Vector $i^n$ in productIndices($s^n$))
          $M_i$(insertEntry($i^n$, $n$, $f$)) = false;
  }
  // Deactivates face functions if neighbor exists with different level
  void deactivateOnInternalBoundaries(MaskList& $M$, Neighbors $N$, Levels $L$)
  {
      for(int $a$ from 0 to d - 1)             // For d coordinate axes
          for(int $f$ from 0 to 1)             // For two faces
              for(int $i$ from 0 to size($M$))    // For all cells
                  if(int $N_a$ = $N$($i$, $a$, $1$); $N_a \neq -1$ and $L$($i$) != $L$($N_a$)) 
                      deactivateSlice($M$($i$), $a$, $f$);
  }
  
  MaskList createMlhpMasks(Neighbors $N$, Levels $L$, Isleaf $E$, Degrees $p$)
  {   
      MaskList $M$; int l = 0;

      // Step 1: Initialize leaf masks (could use trunk space here instead)
      for(bool $i$ from 0 to size($E$) - 1)
          $M$.append(Mask($p$($l$++) + 1, true) if $E$($i$) else Mask(0));
          
      // Step 2: Restore compatibility by activating on neighbors
      for(int it from 0 to d - 1)
          operateOnInterfaces($M$, $N$, $L$, logicalOr);
      
      // Step 3: Impose Dirichlet on internal boundaries
      deactivateOnInternalBoundaries($M$, $N$, $L$);
      
      // Step 4: Restore compatibility by deactivating on neighbors
      for(int it from 0 to d - 2)
          operateOnInterfaces($M$, $N$, $L$, logicalAnd);
      
      return $M$;
  }
  
  void createMlhpLocationMatrices(MaskList $M$, Neighbors $N$, Levels $L$)
  {
      LocationMatrixList $G$, int $n_{\text{ids}}$ = initializeGlobalIndices($M$);
      
      for(int it from 0 to d - 1) 
        operateOnInterfaces($G$, $N$, $L$, maximum);
        
      removeUnassignedIndices($G$, $n_{\text{ids}}$);
      
      return $G$;  
  }
\end{lstlisting}
\caption{Construct multi-level $hp$ tensor-product masks.}%
\label{alg:mlhp:masks:construction}%
\end{algorithm}%

\begin{algorithm}%
\begin{lstlisting}[gobble=2,mathescape]
  // Evaluate multi-level hp basis at local coordinates $\comment{r}$ of cell $\comment{i}$, differentiated
  // $\comment{k}$($\comment{a}$) times in direction $\comment{a}$. For example, $\comment{k}$ = (1, 0) evaluates $\comment{\partial N_j}$/$\comment{\partial r_0}$ in 2D and
  // $\comment{k}$ = (0, 1, 1) evaluates $\comment{\partial^2 N_j}$/($\comment{\partial y \, \partial r_2}$) in 3D. Note that this function only maps 
  // the derivatives into the leaf coordinate system, not yet into global space.
  Vector evaluate(Mesh mesh, MaskList $M$, int $i_l$, Coords $r$, Diff $k$)
  {
      Vector $N$ = [ ];    // shape functions
      double $n_L$ = 0;      // number of levels
      
      // Loop from leaf to root: start with full index of leaf and update to
      // parent in each new iteration until current cell has no parent (-1)
      for(int $i$ = $i_l$; $i$ $\neq$ -1; $i$ = mesh.parent($i$))
      {
          Mask $M_i$ = $M$($i$);
          Vector $s$ = sizes($M_i$);

          if(product($s$) $\neq$ 0)
          {            
              // Evaluate integrated Legendre polynomials
              VectorList $I$;
              
              for(int $a$ from 0 to $d$ - 1)
                  $I$.append(integratedLegendre($r$($a$), $s$($a$) - 1, $k$($a$)));
              
              // Append active entries in tensor-product to $\comment{N}$
              for(Vector $\alpha$ in productIndices($s$))
              {
                  if($M_i$($\alpha$))
                  {
                      // Map derivatives to leaf
                      double $N_{\alpha}$ = power($1/2$, $n_L$ * sum($k$));
                      
                      // Multiply in directions $\comment{j}$ with polynomial at index $\comment{\alpha(j)}$, 
                      // differentiated $\comment{k(j)}$ times, evaluated at $\comment{r(j)}$
                      for(int $j$ from 0 to $d$ - 1)
                          $N_{\alpha}$ = $N_{\alpha}$ * $I$($j$)($\alpha$($j$))
                      
                      $N$.append($N_{\alpha}$);
                  }
              }
          }
          
          // Map coordinate to parent
          for(int $a$ from 0 to $d$ - 1)
          {
              int $N_a$ = mesh.neighbor($i$, $a$, 0);
              
              double $c$ = -1 if $N_a$ == -1 or mesh.parent($N_a$) != mesh.parent($i$) else 1
              
              $r$($a$) = ($r$($a$) + c) / 2;
          }
          
          $n_L$ = $n_L$ + 1;
      }
      
      return $N$; 
  }
\end{lstlisting}
\caption{Evaluate multi-level $hp$-basis functions.}%
\label{alg:mlhp:masks:basisevaluation}%
\end{algorithm}%

% Step 1 
\vspace{0.5em}\noindent
\textbf{1. Initialize leaf masks according to their polynomial degree and non-leaf masks empty}. Activating the complete tensor-product or trunk space only on the leaves naturally yields shape functions that are \review{linearly} independent over the hierarchy, as none of the parents contribute any shape functions. Choosing the trunk space masks derived in Section~\ref{sec:pfem:trunkspace} instead of activating the full tensor-product does not require any changes in the remaining parts of the algorithm. Figure~\ref{fig:mlhp:masks:construction:initial} shows the initial tensor-product masks with the corresponding shape functions using the full tensor-product space according to the degrees specified by Figure~\ref{fig:mlhp:masks:degrees}. In the current state, the shape functions cannot be combined into continuous basis functions yet as they are not compatible along the cell interfaces (red color). Moreover, the shape functions on the internal boundaries on the first and second overlay meshes are still active, as no Dirichlet conditions were imposed yet (violet color). 

% Step 2 
\vspace{0.5em}\noindent%
\textbf{2. Restore interface compatibility using logical \textit{or} operations in $d$ iterations.} In a loop over the internal interfaces, a tensor-product mask \review{entry} is activated if the corresponding entry in the neighbor is active. Internal interfaces bound two cells of the same refinement level, which makes this step equivalent to treating the \review{cells} of each refinement level as separate $p$-finite element meshes and applying the algorithm of Section~\ref{sec:pfem:masks} to them independently. This serves two purposes: first, it resolves incompatible polynomial degrees by the \textit{maximum degree strategy}, and second, it activates the interface shape functions on the parent elements of finer neighbors. Figures~\ref{fig:mlhp:masks:construction:step2:x}~-~\ref{fig:mlhp:masks:construction:step2:y} demonstrate the two necessary iterations in the current step of the tensor-product mask creation for the two-dimensional example introduced earlier. The shape functions on the bottom right cell of level zero can now be completed on the neighboring cells of the same level, although these cells have been refined and now also support up to two levels of finer overlay cells. Two iterations of this algorithm activate all four linear shape functions that together form the central hat basis function on level zero. The second iteration activates, in this example, the single bilinear shape function in cell $1$ (top left) on level zero.

% Step 3
\newpage 
\vspace{0.5em}\noindent
\textbf{3. Deactivate shape functions on internal boundaries.} The final step of constructing a multi-level $hp$-basis is to filter basis functions that are non-zero on the internal boundaries of the overlays (i.e., homogeneous Dirichlet conditions must be imposed). Thus, entries in the tensor-product masks are deactivated for shape functions that are non-zero on faces with a coarser neighbor. As Figure~\ref{fig:mlhp:masks:construction:step3} shows, this step deactivates the shape functions on levels one and two that are active on the internal boundary to the bottom right cell of level zero. Note that the shape functions deactivated here are already active on a parent cell due to the preceding compatibility recovery in the second step. Moreover, external boundaries are not modified as there are no hanging nodes, and the finest resolution is desirable there (as already initialized in step 1).

% Step 4
\vspace{0.5em}\noindent
\textbf{4. Restore interface compatibility using logical \textit{and} operations in $d - 1$ iterations.} The basis functions on internal interfaces often receive contributions from additional elements. For example, on level two of Figure~\ref{fig:mlhp:masks:construction:step3}, the basis function associated with the node in the central corner is built from three linear shape functions supported on the three surrounding elements (cells 19, 22, and 24), but only two of them are deactivated (on cells $19$ and $24$, as only they are directly connected to the internal boundary). Such remaining contributions are deactivated by repeating the second step of the algorithm, but with one less repetition and with logical \textit{and} operations. This deactivates interface shape functions if they are inactive in the neighbor, which only affects the changes from step 3, as all other interfaces are compatible after step 2. Figure~\ref{fig:mlhp:masks:construction:step4:x} shows the final step of this algorithm for creating compatible multi-level $hp$ tensor-product masks.

\vspace{0.5em}\noindent
The tensor-product masks allow an evaluation of the basis functions in each finite element by first evaluating the integrated Legendre polynomials in each direction and then computing the active entries within the tensor-product according to the corresponding mask. The derivatives are mapped into the global coordinate system (physical space) if needed. The evaluation starts on the leaves and is repeated for each parent cell in the hierarchy towards the root cell. With each new level, the evaluation coordinates must be mapped accordingly. Algorithm~\ref{alg:mlhp:masks:basisevaluation} shows the basis function evaluation for a multi-level $hp$-element.

\begin{figure}[hb!]
    \includeTikz{}{mlhp_maps_initial}%
    \caption{Initialize global ids independently. \reprintedA}
    \label{fig:mlhp:locationmaps:construction:a}
\end{figure}

\CopiedSection{\footnotemark[1]}{Location matrices}
\label{sec:mlhp:locationmaps}

\begin{figure}[h]
    \centering Connect horizontally \vspace{0.2cm}
    
    \includeTikz{}{mlhp_maps_step2x}%
    
    \vspace{0.2cm} \centering Connect vertically \vspace{0.2cm}
    
    \includeTikz{}{mlhp_maps_step2y}%
    \caption{Connect global ids over cell interfaces. \reprintedA}
    \label{fig:mlhp:locationmaps:construction:b}
\end{figure}

\begin{figure}
    \includeTikz{}{mlhp_maps_step4}%
    \caption{Eliminate unassigned global basis function indices. \reprintedA}
    \label{fig:mlhp:locationmaps:construction:c}
\end{figure}

\begin{figure}
    \includeTikz{}{mlhp_maps_final_basis1}%
    \caption{Multi-level $hp$ basis functions \numrange{0}{27} according to Figure~\ref{fig:mlhp:locationmaps:construction:c}.}
    \label{fig:mlhp:locationmaps:basisfunctions1}
\end{figure}

\begin{figure}
    \includeTikz{}{mlhp_maps_final_basis2}%
    \caption{Multi-level $hp$ basis functions \numrange{28}{48} according to Figure~\ref{fig:mlhp:locationmaps:construction:c}.}
    \label{fig:mlhp:locationmaps:basisfunctions2}
\end{figure}

In this section, the active shape functions on the cells of the hierarchical refinement tree from the previous section are connected to global multi-level $hp$-basis functions by using the ideas of Section~\ref{sec:pfem:masks}. Each refinement level is again treated like a separate $p$-finite element mesh to construct the location matrices using the same steps as in Section~\ref{sec:pfem:masks}. In other words: the shape functions are connected only across internal interface and not across interfaces to coarser neighbors. In contrast to the multi-level $hp$ tensor-product masks, the construction of the location matrices does not need to be further adapted to account for the mesh hierarchy and the different types of cell faces. Figure~\ref{fig:mlhp:locationmaps:construction:a} shows the initial location matrices corresponding to the tensor-product masks from Figure~\ref{fig:mlhp:masks:construction:step4:x}, where each shape function is assigned a unique index. These are then connected in both coordinate directions in Figure~\ref{fig:mlhp:locationmaps:construction:b}, and the resulting gaps in the global numbering are eliminated in Figure~\ref{fig:mlhp:locationmaps:construction:c} by applying an index map like in Figure~\ref{fig:pfem:locationmaps:construction:d}. The complete set of multi-level $hp$ basis functions is shown in Figures~\ref{fig:mlhp:locationmaps:basisfunctions1}~-~\ref{fig:mlhp:locationmaps:basisfunctions2}. The last function of Algorithm~\ref{alg:mlhp:masks:construction} constructs the location matrices for a multi-level $hp$-basis.

%\newpage

\begin{remark}
  \item The example features only two levels of refinement. The algorithms, however, apply to arbitrary nested spacetree partitions. They only distinguish between leaf- and non-leaf cells and between different types of cell faces. 
\end{remark}

%\newpage 

\begin{remark}
  \item In practice, one might encapsulate the topological and geometric data from Section~\ref{sec:mlhp:datastructure} into a mesh data type and the results of Sections~\ref{sec:mlhp:masks}~-~\ref{sec:mlhp:locationmaps} into an $hp$-basis data type.
\end{remark}

%\section{Assembly and solution of the linear equation system}
\CopiedSection{\footnotemark[1]}{Simulation workflow}
\label{sec:mlhp:workflow}

In a computation with multi-level $hp$-finite elements, the algorithms from Sections~\ref{sec:mlhp:masks} and~\ref{sec:mlhp:locationmaps} directly follow the mesh creation to prepare the tensor-product masks and location matrices.
Both are defined on all cells of the refinement tree. Theoretically, \review{one could} consider each cell a finite element and assemble their contributions separately. However, the volumetric coupling of the basis functions through the hierarchy renders this approach impractical, as the interactions between all the cells in the tree must be integrated. Moreover, the concept of overlapping finite elements is not very transparent for someone concerned with practical applications who may not be familiar with the details of the method.
%
\begin{figure}[h]
  %\setlength{\mathindent}{0.7cm}
  \begin{alignat*}{6}
      \text{element } & 0   && : \; [ \, \textcolor{purple}{0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,}                                             \quad & 
      \text{element } & 11  && : \; [ \, 44, 45, \textcolor{darkgreen}{19, 22, 23, 25}, \textcolor{blue}{0, 1, 2, 3}  \, ]       \\
                      &     && \hspace{1cm} \textcolor{purple}{12, 13, 14, 15}                                                            \, ] \quad & 
      \text{element } & 12  && : \; [ \, 44, \textcolor{darkgreen}{19, 22, 23, 25}, \textcolor{blue}{0, 1, 2, 3}      \, ]       \\
      \text{element } & 1   && : \; [ \, 16, 17, 18, 19,         \textcolor{blue}{0, 1, 2, 3}                         \, ]       & 
      \text{element } & 13  && : \; [ \, 44, 45, \textcolor{darkgreen}{19, 22, 23, 25}, \textcolor{blue}{0, 1, 2, 3}  \, ]       \\
      \text{element } & 2   && : \; [ \, 17, 20, 21, 19, 22, 23, \textcolor{blue}{0, 1, 2, 3}                         \, ]       & 
      \text{element } & 14  && : \; [ \, 45, 46, \textcolor{darkgreen}{22, 28, 29, 32, 33}, \textcolor{blue}{1}       \, ]       \\
      \text{element } & 3   && : \; [ \, 18, 19, 24, 25,         \textcolor{blue}{0, 1, 2, 3}                         \, ]       & 
      \text{element } & 15  && : \; [ \, 46, \textcolor{darkgreen}{22, 28, 29, 32, 33}, \textcolor{blue}{1}           \, ]       \\
      \text{element } & 4   && : \; [ \, 20, 26, 27, 22, 28, 29, \textcolor{blue}{1}                                  \, ] \quad & 
      \text{element } & 16  && : \; [ \, 45, 46, 47, \textcolor{darkgreen}{22, 28, 29, 32, 33}, \textcolor{blue}{1}   \, ]       \\
      \text{element } & 5   && : \; [ \, 26, 30, 28, 31,         \textcolor{blue}{1}                                  \, ]       & 
      \text{element } & 17  && : \; [ \, 46, 47, \textcolor{darkgreen}{22, 28, 29, 32, 33}, \textcolor{blue}{1}       \, ]       \\
      \text{element } & 6   && : \; [ \, 28, 31, 32, 34, 33, 35, \textcolor{blue}{1}                                  \, ]       & 
      \text{element } & 18  && : \; [ \, 47, 48, \textcolor{darkgreen}{32, 36, 37, 38}, \textcolor{blue}{1, 5, 9, 13} \, ]       \\
      \text{element } & 7   && : \; [ \, 32, 34, 36, 39, 38, 40, \textcolor{blue}{1, 5, 9, 13}                        \, ] \quad  & 
      \text{element } & 19  && : \; [ \, 47, 48, \textcolor{darkgreen}{32, 36, 37, 38}, \textcolor{blue}{1, 5, 9, 13} \, ]       \\
      \text{element } & 8   && : \; [ \, 36, 37, 41, 42,         \textcolor{blue}{1, 5, 9, 13}                        \, ]       & 
      \text{element } & 20  && : \; [ \, 48, \textcolor{darkgreen}{32, 36, 37, 38}, \textcolor{blue}{1, 5, 9, 13}     \, ]       \\
      \text{element } & 9   && : \; [ \, 36, 39, 41, 43,         \textcolor{blue}{1, 5, 9, 13}                        \, ]       & 
      \text{element } & 21  && : \; [ \, 48, \textcolor{darkgreen}{32, 36, 37, 38}, \textcolor{blue}{1, 5, 9, 13}     \, ]       \\
      \text{element } & 10  && : \; [ \, 44, \textcolor{darkgreen}{19, 22, 23, 25}, \textcolor{blue}{0, 1, 2, 3}      \, ]
  \end{alignat*}
  \vspace{-0.7cm}
  \caption{Element location maps including parent cells (colors represent parent levels). \reprintedA}
  \label{fig:mlhp:workflow:locationmaps}
\end{figure}
%
Instead, only the leaves are considered finite elements. When evaluating the shape functions, the contributions of all parent elements are simply appended while traversing the hierarchy and mapping the evaluation coordinates accordingly. Therefore, from ''outside'', the multi-level $hp$-basis consists of the non-overlapping leaves, where some of them evaluate more shape functions than others (\review{e.g.,} in transition zones with many hanging nodes). Hiding the hierarchical nature of the basis (which still exists internally) allows treating the multi-level hp-basis like any other finite element method and applying standard algorithms. Equivalent to gathering the shape function over the full hierarchy, the global basis function indices in all location matrices are concatenated \review{into} a single location map for each finite element. Figure~\ref{fig:mlhp:workflow:locationmaps} shows these location maps for the hierarchical example of this chapter. As many finite elements share the same parent shape functions, some indices appear quite often. This redundancy \review{is eliminated by storing} the location maps for each cell and only combine them on the fly for individual leaves when necessary.

After the mesh and basis construction, the location maps of the multi-level $hp$-basis are used to allocate a sparse matrix in a compressed-sparse-row (CSR) format and a dense load vector. This ensures that the subsequent assembly loop over all elements can add the element matrices to the global matrix without allocating new non-zero entries. 
For each element, the corresponding location map is used to allocate a dense element matrix and an element load vector according to the length of the location map. The number of Gauss-Legendre points per direction is determined by querying the basis for the maximum polynomial degrees of the element, which are obtained from the sizes of the tensor-product masks of the element and its parents. For each integration point (usually $p + 1$ per direction), the shape functions and their derivatives are evaluated, and the finite element integrals are added to the element system. Finally, the element matrix and element load vector are assembled into the global system using the current location map.

The resulting global linear system is then solved using either a diagonally preconditioned conjugate gradient method (time-stepping) or the Pardiso sparse direct solver (space-time slab). Both perform well for any number of refinement levels on the examples shown in this thesis. 
The multi-level $hp$-method has been combined with Additive-Schwarz~\parencite{Jomo2018} and multigrid preconditioners~\parencite{Jomo2021} (exploiting the hierarchical nature) or with sparse direct solvers~\parencite{Elhaddad2017}. After the linear solution, quantities of interest, like the solution field, are written to the hard drive using the VTU file format for visualization in Paraview. The high-order nature of the approximation is captured by evaluating the solution field inside an element on a finer sample grid whose resolution is chosen in relation to the polynomial degree.

\CopiedSection{\footnotemark[2]}{Refinement strategy based on laser path}
\label{sec:mlhp:lpbfrefinement}

\begin{figure}[htb]
  \centering
  \begin{minipage}[c]{0.55\linewidth} 
    \vspace{0pt}
    \includeTikz{width=\linewidth, height=0.53\linewidth}{refinement_history_graph}%
  \end{minipage}%
  \hfill
  \begin{minipage}[c]{0.43\linewidth}
    {
      \renewcommand{\arraystretch}{1.16} % Default value: 1
      \hfill
      \begin{tabular}{ lll }
        \toprule
        delay [ms] & \textcolor{blue}{depth} $[-]$ & \textcolor{darkgreen}{sigma} [\si{\micro\meter}] \\ 
        \midrule
        0.0    & 5.4   & 180  \\
        1.2    & 3.5   & 240  \\
        6.0    & 2.5   & 400  \\
        30.0   & 1.5   & 900  \\
        100.0  & 1.0   & 1100 \\
        \bottomrule
      \end{tabular}
      \vspace{2ex}
    }
  \end{minipage}%
  \caption{Parameters for refinement based on laser history inside the refinement window $[t - \tau_{\text{max}}, t]$. \reprintedB}
  \label{fig:mlhp:lpbfrefinement:parameters} 
\end{figure}


It is crucial to find strategies for automatic mesh refinement, mesh coarsening, and polynomial degree selection to use the flexibility offered by an $hp$ framework to its full potential. 
%
\begin{figure}[b!]
  \centering
  \includeTikz{}{refinement_level_evaluation}%
  \caption{Evaluation of the depth function $d(x, t)$ at $x = (\SI{4}{\milli\meter}, \SI{1}{\milli\meter})$, $t = \SI{25}{\milli\second}$ by finding the closest point on each laser path segment (a square contour with \SI{6}{\milli\meter} side length).}
  \label{fig:mlhp:lpbfrefinement:evaluation}
\end{figure}
%
\begin{figure}
  \begin{minipage}[b]{0.32\linewidth} 
    \includegraphics[width=\linewidth]{\picsDir/refinement_solution.jpg}
    \subcaption{Computed temperature}
  \end{minipage}%
  \hfill
  \begin{minipage}[b]{0.32\linewidth} 
    \includegraphics[width=\linewidth]{\picsDir/refinement_level_function.png}
    \subcaption{Refinement depth function}
  \end{minipage}%
  \hfill
  \begin{minipage}[b]{0.32\linewidth} 
    \includegraphics[width=\linewidth]{\picsDir/refinement_mesh.png}
    \subcaption{Finite element mesh}
  \end{minipage}%
  % \caption{Mesh refinement using the parameters from Figure~\ref{fig:mlhp:lpbfrefinement:parameters} on a \SI{6}{\milli\meter} by \SI{6}{\milli\meter} square. \reprintedB}
  \caption{The depth function in the middle defines the target number of multi-level hp refinements. It evaluates \eqref{eq:refinementfunction} using the path shown in Figure~\ref{fig:mlhp:lpbfrefinement:evaluation} and the parameters from Figure~\ref{fig:mlhp:lpbfrefinement:parameters}. The resulting mesh to the right captures the temperature on the left side well. \reprintedB}
  \label{fig:mlhp:lpbfrefinement:results} 
\end{figure}
%
General approaches use error estimators combined with some smoothness estimators to choose whether to refine in $h$ or $p$. While these require little problem setup information, they are often expensive and complex to implement. However, in applications such as \gls*{LPBF}, the a priori knowledge about the laser path can be used to tailor mesh refinement strategies. In this thesis, the mesh is refined by considering recent laser positions, called the refinement window (e.g., from \SI{100}{\milli\second} in the past until the present time), for constructing a function conceptually similar to a mesh density function that defines the target refinement depth. This function is constructed starting with a Gauss bell shape at the current position of the laser with a maximum refinement depth at the center that decreases while moving further away from the laser. Then, this function is transported in space along the previous laser path, decreasing the maximum refinement level and increasing the refinement width. This transport yields a spatial function for a given point in time with values indicating the target refinement level. The decision to refine an element is made by evaluating the refinement depth function on a grid of points within the element (e.g., \numrange{5}{7} per direction) and comparing the maximum target refinement depth to the refinement level of the element. Figure~\ref{fig:mlhp:lpbfrefinement:parameters} shows the maximum refinement depth $d_{\tau}$ and width $\sigma_{\tau}$ defined over the refinement window (the recent laser history) as used later in the examples.

The refinement depth function $d(x, t)$ is evaluated by considering the laser path in the time interval $[t - \tau_{\text{max}}, t]$; the regions before and after do not influence the refinement. The function evaluation first computes the closest point $x^p_i$ on each laser path segment $i$ and determines the time $t^p_i$ at which the laser was at $x^p_i$. Then, using the time delay $\Delta t_i = t - t_i^p$, the maximum refinement depth and width are extracted from the functions $d_{\tau}(\Delta t)$ and $\sigma_{\tau}(\Delta t)$, respectively; \review{see} Figure~\ref{fig:mlhp:lpbfrefinement:parameters}. These allow computing $d(x, t)$ by evaluating a Gaussian function for each segment and taking the maximum value:
%
\begin{equation}\label{eq:refinementfunction}
d(x, t) = \max_i d_i(x, t) = \max_i \left ( d_{\tau} \big ( t - t^p_i \big ) \exp{\left ( - \frac{\lVert x - x_i^p \rVert^2}{2\sigma^2_{\tau}(t - t^p_i)} \right )} \right ),
\end{equation}
%
rounding the result to the closest integer. Figure~\ref{fig:mlhp:lpbfrefinement:evaluation} \review{exemplifies} this process for a square contour path with four segments. The right segment dictates a maximum of one level of refinement after rounding due to its proximity to the evaluation point. All other segments are too far away in relation to the width of the Gauss function, interpolated from Figure~\ref{fig:mlhp:lpbfrefinement:parameters}. \review{Figure~\ref{fig:mlhp:lpbfrefinement:results} shows the} evaluation of $d(x, t)$ on the entire two-dimensional domain\review{,} the resulting mesh\review{,} and the computed temperature field. In this example, the refinement window in Figure~\ref{fig:mlhp:lpbfrefinement:parameters} acts inside the interval $[t - \SI{100}{\milli\second}, t]$. Hence, all four segments must be considered, as the total printing time does not exceed \SI{100}{\milli\second}. However, for longer laser paths (or differently defined refinements), the segments whose time interval does not intersect the window of active refinement ($[t - \tau_{\text{max}}, t]$) may be discarded for a given time $t$.
 
As the presented multi-level $hp$-refinement is isotropic, the same refinement depth applies to all directions, including time. For simplicity, the same polynomial degree is chosen for elements with equal refinement levels, which is not a restriction of the method. Finding better selection criteria for the polynomial degrees of individual elements will improve the simulation performance; future work will focus on this.

\CopiedSection{\footnotemark[2]}{Slab compatibility}
\label{sec:mlhp:slabcompatibility}

\begin{figure}[h]
  \begin{minipage}[b]{0.33\linewidth} 
    \includeTikz{width=\linewidth}{slab_compatibility_1}%
    \subcaption{First slab}
  \end{minipage}%
  \hfill
  \begin{minipage}[b]{0.33\linewidth} 
    \includeTikz{width=\linewidth}{slab_compatibility_2}%
    \subcaption{Second slab}
  \end{minipage}%
  \hfill
  \begin{minipage}[b]{0.33\linewidth} 
    \includeTikz{width=\linewidth}{slab_compatibility_3}%
    \subcaption{Third and last slab}
  \end{minipage}%
  \caption{Ghost slabs in time with one space dimension. \reprintedB}
  \label{fig:mlhp:slabcompatibility:ghostslabs} 
\end{figure}

Another challenge in separating the solution into time slabs is that hanging nodes are not constrained when meshing each slab separately. Meshing the entire space-time domain at once is certainly not desirable. Still, the refinement for the next and previous slabs must be known to construct compatible bases at slab interfaces. Figure~\ref{fig:mlhp:slabcompatibility:ghostslabs} shows how a one-dimensional solution is advanced in time by meshing the second slab together with the first one. \review{This allows the basis of the first slab to ''know'' the hanging nodes on the time interfaces to the second slab.} Then, before \review{creating the basis for} the second slab, the third one is meshed, and only when computing the solution on the third slab is the first mesh discarded. This meshing procedure is possible as the refinement does not depend on the solution and is defined in advance. In other cases (e.g., when using an adaptive algorithm), one can either refine the next slab conformingly or use a \gls*{DG} formulation in time to enforce continuity across slab interfaces weakly \parencite[see, e.g.,][]{Hofer2018, Schmich2008}.

}